unit UnidadDatos;

interface

uses
  SysUtils, Classes, DBTables, DB, dialogs, bde;

type
  TDatos = class(TDataModule)
    DConsumo: TDataSource;
    DSeguros: TDataSource;
    TConsumo: TTable;
    TConsumoID: TAutoIncField;
    TConsumoMatricula: TStringField;
    TConsumoConductor: TIntegerField;
    TConsumoKm: TFloatField;
    TConsumoLitros: TFloatField;
    TConsumoFecha: TDateField;
    TConsumoLChofer: TStringField;
    TConsumoLMatricula: TStringField;
    TConsumoConsumo: TFloatField;
    TSeguros: TTable;
    TSegurosID: TAutoIncField;
    TSegurosChofer: TIntegerField;
    TSegurosMatricula: TStringField;
    TSegurosTonelaje: TFloatField;
    TSegurosTipo: TStringField;
    TSegurosEstado: TStringField;
    TSegurosCSegurosMercancias: TIntegerField;
    TSegurosCSegurosObligatoria: TIntegerField;
    TSegurosVencimientoSeguro: TDateField;
    TSegurosVencimientoITV: TDateField;
    TSegurosVencimientoTacog: TDateField;
    TSegurosVencimientoTarjeta: TDateField;
    TSegurosServicioMercancia: TStringField;
    TSegurosAgente: TIntegerField;
    TSegurosPropuesta: TStringField;
    TSegurosImporteSeguro: TCurrencyField;
    TSegurosLChofer: TStringField;
    TSegurosCSMercancia: TStringField;
    TSegurosCSObligatoria: TStringField;
    TSegurosLAgente: TStringField;
    TSegurosLMatricula: TStringField;
    TCompanias: TTable;
    DCompanias: TDataSource;
    ConsultaConsumo: TQuery;
    DAgentes: TDataSource;
    DVehiculos: TDataSource;
    Consulta: TQuery;
    TVehiculos: TTable;
    TVehiculosMatricula: TStringField;
    TVehiculosNota: TStringField;
    TVehiculosChofer: TIntegerField;
    TVehiculosLChofer: TStringField;
    TVehiculosTonelaje: TFloatField;
    TVehiculosActivo: TStringField;
    TVehiculosTipo: TStringField;
    TVehiculosEstado: TStringField;
    TVehiculosServicio: TStringField;
    TAgentes: TTable;
    TKm: TTable;
    DKm: TDataSource;
    DChofer: TDataSource;
    C: TQuery;
    TChofer: TTable;
    DS: TDataSource;
    TS: TTable;
    TConsumoImporte: TCurrencyField;
    procedure TAgentesAfterPost(DataSet: TDataSet);
    procedure TAgentesPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
    procedure TChoferAfterInsert(DataSet: TDataSet);
    procedure TChoferAfterPost(DataSet: TDataSet);
    procedure TChoferPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
    procedure TCompaniasAfterInsert(DataSet: TDataSet);
    procedure TCompaniasAfterPost(DataSet: TDataSet);
    procedure TCompaniasPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
    procedure TConsumoAfterCancel(DataSet: TDataSet);
    procedure TConsumoAfterEdit(DataSet: TDataSet);
    procedure TConsumoAfterPost(DataSet: TDataSet);
    procedure TSegurosAfterCancel(DataSet: TDataSet);
    procedure TSegurosAfterDelete(DataSet: TDataSet);
    procedure TSegurosAfterEdit(DataSet: TDataSet);
    procedure TVehiculosAfterInsert(DataSet: TDataSet);
    procedure TVehiculosAfterPost(DataSet: TDataSet);
    procedure TVehiculosPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Datos: TDatos;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;


procedure TDatos.TAgentesAfterPost(DataSet: TDataSet);
begin
  tagentes.FlushBuffers;
end;

procedure TDatos.TAgentesPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('El agente introducido ya existe, elimnelo antes de continuar.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;

procedure TDatos.TChoferAfterInsert(DataSet: TDataSet);
begin
  formmenuprincipal.tablachofer.SetFocus;
//  if formMenuPrincipal.Tabl.Visible then
//    formMenuPrincipal.TablaDiarioMes.Field.FocusControl;

end;

procedure TDatos.TChoferAfterPost(DataSet: TDataSet);
begin
  tchofer.FlushBuffers;
end;

procedure TDatos.TChoferPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('El conductor introducido ya existe, elimnelo antes de continuar.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;

procedure TDatos.TCompaniasAfterInsert(DataSet: TDataSet);
begin
  formmenuprincipal.tablacompania.SetFocus;
//  if formMenuPrincipal.TablaDiarioMes.Visible then
//    formMenuPrincipal.TablaDiarioMes.Field.FocusControl;

//  formmenuprincipal.tablacompania.selectedindex:=0;
end;

procedure TDatos.TCompaniasAfterPost(DataSet: TDataSet);
begin
  tcompanias.FlushBuffers;
end;

procedure TDatos.TCompaniasPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('La compaa introducida ya existe, elimnela antes de continuar.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;

procedure TDatos.TConsumoAfterCancel(DataSet: TDataSet);
begin
  formmenuprincipal.bvalidarconsumo.enabled := false;
  formmenuprincipal.bcancelar.enabled := false;
end;

procedure TDatos.TConsumoAfterEdit(DataSet: TDataSet);
begin
  formmenuprincipal.bvalidarconsumo.enabled := true;
  formmenuprincipal.bcancelar.enabled := true;
end;

procedure TDatos.TConsumoAfterPost(DataSet: TDataSet);
begin
  tconsumo.flushbuffers;
  formmenuprincipal.bvalidarconsumo.enabled := false;
  formmenuprincipal.bcancelar.enabled := false;
end;

procedure TDatos.TSegurosAfterCancel(DataSet: TDataSet);
begin
  formmenuprincipal.bvalidarseguros.enabled := false;
  formmenuprincipal.bcancelarseguros.enabled := false;
end;

procedure TDatos.TSegurosAfterDelete(DataSet: TDataSet);
begin
  tseguros.FlushBuffers;
  formmenuprincipal.bvalidarseguros.enabled := false;
  formmenuprincipal.bcancelarseguros.enabled := false;
end;

procedure TDatos.TSegurosAfterEdit(DataSet: TDataSet);
begin
  formmenuprincipal.bvalidarseguros.enabled := true;
  formmenuprincipal.bcancelarseguros.enabled := true;
end;

procedure TDatos.TVehiculosAfterInsert(DataSet: TDataSet);
begin
  formmenuprincipal.tabvehiculos.show;
  formmenuprincipal.tablavehiculos.SetFocus;
//  formmenuprincipal.tablavehiculos.selectedindex := 0;
end;

procedure TDatos.TVehiculosAfterPost(DataSet: TDataSet);
begin
  tvehiculos.FlushBuffers;
end;

procedure TDatos.TVehiculosPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('El camin que intenta introducir ya existe.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en el camin actual.');
  end;
end;



end.

