unit UnidadProcedimientos;

interface

uses classes, dbierrs, dbtables, SysUtils, registry,
  Windows, Messages, Variants, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, Buttons, DB, ExtCtrls,
  Grids, DBGrids, shellapi,inifiles;

  function bdeInstalado () : boolean;
  function ejecutadaYa (nombreAplicacion : string) : boolean;
  function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                        crear : boolean) : string;
  procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
                             crear : boolean);
  function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
  function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function ValidarCIF (Cif : string) : boolean;
  function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
  function leEntINI (clave, cadena : string; defecto : integer) : integer;
  function leCadINI (clave, cadena : string; defecto : string) : string;
  procedure esBoolINI (clave, cadena : string; valor : boolean);
  procedure esEntINI (clave, cadena : string; valor : integer);
  procedure esCadINI (clave, cadena, valor : string);
  procedure esFloatINI (clave, cadena : string; valor : double);
  procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
  function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
  function leFloatINI (clave, cadena : string; defecto : double) : double;

  var
    VTIDEmpresa, vtejecucionsiempre:integer;
    VTNombreEmpresa, VTNombreAplicacion, VTVersionAplicacion: String;
    VTRutaEmpresa, VTMonedaEmpresa, VTContrasena, VTUsuario: String;
    VTCambioMonedaEmpresa: double;
    VTInicioEmpresa, VTFinEmpresa, VTFCInicio, VTFCFin : tdatetime;
    VTProgreso, VTEtiquetas, VTFlat, VTEstadoCarga, VTMostrarBB,
        VTEnvaseSeparar, VTEmpresaAnterior: integer;
    VTMostrarBE, VTMostrarFiltro, VTMostrarTotal, VTPreciosSinIVA: integer;
    VTKgCaja, VTPorcentajeMinimo, VTPorcentajeMaximo: double;
    VTMostrarBBVentanas, VTAvisarObreroCuadrilla : integer;
    VTRutaLogotipo, vtfechas, vtinscripcion: string;
    VTCIF, VTTelefono, VTCP, VTProvincia, VTPoblacion: String;
    VTDomicilio: String;
    VTVersionCompleta : integer;
    vtmostrarempresas : integer;
    vtnumeroserie : string;
    claveElegida : string;
    vtFechaTrabajo : tdatetime;

implementation

function ValidarCIF (Cif : string) : boolean;
  var
  Suma, Control : integer;
  n : byte;
begin
  Result:=False;
  Cif:=UpperCase(Cif);
  {El cif debe ser de 9 cifras}
  if Length(Cif)=9 then
  begin
    Suma:= StrToInt(Cif[3])+
    StrToInt(Cif[5])+
    StrToInt(Cif[7]);
    for n := 1 to 4 do
    begin
      Suma:=Suma+ ( (2*StrToInt(Cif[2*n])) mod 10 )+
      ( (2*StrToInt(Cif[2*n])) div 10 );
    end;
    Control := 10-(Suma mod 10);
    if Pos(Cif[1],'XP') <> 0 then
      {Control tipo letra}
      Result:= ( Cif[9] = Chr(64+ Control))
    else
    begin
      {Control tipo nmero}
      if Control =10 then
        Control := 0;
      Result:= ( StrToInt(Cif[9]) = Control);
    end;
  end;
end;

function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leEntINI (clave, cadena : string; defecto : integer) : integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

procedure esBoolINI (clave, cadena : string; valor : boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeBool (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esEntINI (clave, cadena : string; valor : integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeInteger (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFloatINI (clave, cadena : string; valor : double);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteFloat (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFloatINI (clave, cadena : string; defecto : double) : double;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readfloat (clave, cadena, defecto);
  finally
    free;
  end;
end;


function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function Potencia(Base : Double; Exponente : byte) : Double;
  begin
    Result := Exp(Exponente * ln(Base));
  end;
begin
  result := Round(Numero * Potencia(10, PrecisionDec)) / Potencia (10, PrecisionDec);
end;

//para saber si est instaldo el BDE
function fDbiGetSysVersion(SysVerList: TStringList): SYSVersion;
var
  Month, Day, iHour, iMin, iSec: Word;
  Year: SmallInt;
begin
  Check(DbiGetSysVersion(Result));
  if (SysVerList <> nil) then
  begin
    with SysVerList do
    begin
      Clear;
      Add(Format('ENGINE VERSION=%d', [Result.iVersion]));
      Add(Format('INTERFACE LEVEL=%d', [Result.iIntfLevel]));
      Check(DbiDateDecode(Result.dateVer, Month, Day, Year));
      Add(Format('VERSION DATE=%s', [DateToStr(EncodeDate
                (Year, Month, Day))]));
      Check(DbiTimeDecode(Result.timeVer, iHour, iMin, iSec));
      Add(Format('VERSION TIME=%s', [TimeToStr(EncodeTime
                (iHour, iMin, iSec div 1000, iSec div 100))]));
    end;
  end;
end;

//Para saber si est el BDE instalado
function bdeInstalado () : boolean;
var
  hStrList : TStringList;
  Ver : SYSVersion;
begin
{  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('SOFTWARE\Borland\Database Engine', False);
  s := '';
  try
    s := reg.ReadString('CONFIGFILE01');
  finally
    reg.CloseKey;
  end;
  if s = '' then
  begin
    bdeinstalado := false;
    exit;
  end;}
  hStrList := TStringList.Create;
  try
    Ver := fDbiGetSysVersion(hStrList);
  except
    bdeInstalado := false;
    exit;
  end;
  bdeInstalado := true;
end;

//Comprueba si la aplicacin est ejecutndose ya
function ejecutadaYa (nombreAplicacion : string) : boolean;
var
  MiMutex : Thandle;
begin
  mimutex := CreateMutex(nil, true, pchar(nombreAplicacion));
  if MiMutex = 0 then
    result := false
  else
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
      result := true
    else
      result := false;  
  end;
end;


//Leer valor del Regedit
function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                      crear : boolean) : string;
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    leeRegistro := Reg.ReadString(cadena);
  finally
    reg.Free;
  end;
end;


//Escribe valor en el Regedit
procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
                      crear : boolean);
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    Reg.WriteString(cadena, valor);
  finally
    reg.Free;
  end;
end;


//Comprueba si un valor es numrico
function esNumero (valor : string) : integer;
var
  numero : integer;
begin
  try
    numero := strtoint(valor);
  except
    result := -1;
    exit;
  end;
  result := numero;
end;


//Calcula el dgito de control pasando como parmetro la Entidad
//y la oficina juntas y la cuenta
function CalcularDC (Entidad, Cuenta: string) : integer;
const
  Pesos: array[0..9] of integer = (6,3,7,9,10,5,8,4,2,1);
var
  n : byte;
  iTemp : integer;
begin
  iTemp := 0;
  for n := 0 to 7 do
  begin
    iTemp := iTemp + StrToInt(Copy(Entidad, 8 - n, 1)) * Pesos[n];
  end;
  Result := 11 - iTemp Mod 11;
  if (Result > 9) then
    Result := 1 - Result mod 10;
  iTemp := 0;
  For n := 0 to 9 do
   iTemp := iTemp + StrToInt(Copy(Cuenta, 10 - n, 1)) * Pesos[n];
  iTemp := 11 - iTemp mod 11;
  if (iTemp > 9) then
    iTemp := 1 - iTemp mod 10;
  Result := Result * 10 + iTemp;
end;


function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
var
  aPos : Integer;
begin
  aPos := Pos(textoAReemplazar, Cadena);
  Result := '';
  while (aPos <> 0) do begin
    Result := Result + Copy(Cadena, 1, aPos - 1) + textoNuevo;
    Delete(Cadena, 1, aPos + Length(textoAReemplazar) - 1);
    aPos := Pos(textoAReemplazar, Cadena);
  end;
  Result := Result + Cadena;
end;


end.
